> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Update a guidance

PATCH https://api.x.flatfile.com/v1/spaces/{spaceId}/guidance/{guidanceId}
Content-Type: application/json

Updates a guidance with the given id

Reference: https://reference.flatfile.com/api-reference/spaces/update-guidance

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `spaceId` (string, required) — ID of the space
- `guidanceId` (string, required) — ID of the guidance

### Body (application/json)

This endpoint expects a GuidanceApiUpdateData.

- `options` (GuidanceOptions, required) — Options for the guidance

## Response

### 200

- `id` (string, required) — Guidance ID
- `guideSlug` (string, required)
- `options` (GuidanceOptions, required)
- `createdFrom` (string, optional) — The guidance id of the template that was used to create this guidance
- `lastPropagatedAt` (datetime, optional) — The last time the guidance template configuration was propagated to this guidance

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 403 Forbidden Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### GuidanceOptions

- `target` (string, required)
- `trigger` (enum, required)
  - Allowed values: `first`, `hover`, `event`, `manual`
- `type` (enum, required)
  - Allowed values: `sidebar`, `popout`, `tooltip`
- `role` (enum, optional) — The role for which this guidance should be displayed. If not specified, guidance will be shown to both admin and guest users.
  - Allowed values: `admin`, `guest`

### Error

- `message` (string, required)
- `key` (string, optional)

## Examples

**Request**

```json
{
  "options": {
    "target": "getting-started",
    "trigger": "first",
    "type": "sidebar",
    "role": "admin"
  }
}
```

**Response**

```json
{
  "id": "us_gd_YOUR_ID",
  "guideSlug": "getting-started",
  "options": {
    "target": "getting-started",
    "trigger": "first",
    "type": "sidebar",
    "role": "admin"
  },
  "createdFrom": "us_gd_YOUR_ID",
  "lastPropagatedAt": "2023-10-30T16:59:45.735Z"
}
```

**SDK Code**

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID"

payload = { "options": {
        "target": "getting-started",
        "trigger": "first",
        "type": "sidebar",
        "role": "admin"
    } }
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.spaces.updateGuidance("us_sp_YOUR_ID", "us_gd_YOUR_ID", {
    options: {
        target: "getting-started",
        trigger: "first",
        type: "sidebar",
        role: "admin"
    }
});

```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID"

	payload := strings.NewReader("{\n  \"options\": {\n    \"target\": \"getting-started\",\n    \"trigger\": \"first\",\n    \"type\": \"sidebar\",\n    \"role\": \"admin\"\n  }\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"options\": {\n    \"target\": \"getting-started\",\n    \"trigger\": \"first\",\n    \"type\": \"sidebar\",\n    \"role\": \"admin\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"options\": {\n    \"target\": \"getting-started\",\n    \"trigger\": \"first\",\n    \"type\": \"sidebar\",\n    \"role\": \"admin\"\n  }\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID', [
  'body' => '{
  "options": {
    "target": "getting-started",
    "trigger": "first",
    "type": "sidebar",
    "role": "admin"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID");
var request = new RestRequest(Method.PATCH);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"options\": {\n    \"target\": \"getting-started\",\n    \"trigger\": \"first\",\n    \"type\": \"sidebar\",\n    \"role\": \"admin\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["options": [
    "target": "getting-started",
    "trigger": "first",
    "type": "sidebar",
    "role": "admin"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/spaces/us_sp_YOUR_ID/guidance/us_gd_YOUR_ID")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```